#ifndef SKELETON_H
#define SKELETON_H

/*
 * Skeleton.h - a public header for skeleton class
 *
 * Public Domain.
 *
 * Christian E. Hopps.
 *
 */

#ifndef INTUITION_CLASSES_H
#include <intuition/classes.h>
#endif

#ifndef INTUITION_CLASSUSR_H
#include <intuition/classusr.h>
#endif

#ifndef UTILITY_TAGITEM_H
#include <utility/tagitem.h>
#endif

/*
 * Tag attributes for skeleton class.
 */

/* Note: valid User tags are TAG_USER + 0x0001 thru */
/* TAG_USER + 0x9999 until "further notice." (C=)   */

#define SKA_Dummy (TAG_USER + 0x0000)
#define SKA_NoOp  (SKA_Dummy + 0x1)

/*
 * Public functions for skeleton Class.
 *
 */
Class * Skeleton_init( void );
ULONG   Skeleton_free( Class * );

#endif